/*
	locale(1)
	Copyright 1996,1999 (C) ITO Takayuki
*/

#include	<sys/types.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"locale.h"

char	*env_lc_all = NULL;

void	DisplayLocale	(int category, char *env)
{
	char	*p, *q;

	p = getenv (env);
	if (p != NULL && p [0] == '\0')
		p = NULL;
	q = setlocale (category, "");		/* set and query this category */
	if (env_lc_all == NULL && 			/* not set by %LC_ALL% */
		p != NULL && 					/* this env. var. has any value */
		q != NULL)						/* it's valid value */
		printf ("%-11s =  %s\n", env, q);
	else
		printf ("%-11s = \"%s\"\n", env, q != NULL ? q : "");
}

int	main	(int argc, char **argv)
{
	char	*p;

#if 0
	if (setlocale (LC_ALL, "") == NULL)
	{
		fputs ("setlocale() failed.\n", stderr);
		exit (EXIT_FAILURE);
	}
#endif

	env_lc_all = getenv ("LC_ALL");
	if (env_lc_all != NULL && env_lc_all [0] == '\0')
		env_lc_all = NULL;

	fputs ("LANG        =  ", stdout);
	if ((p = getenv ("LANG")) != NULL)
		fputs (p, stdout);
	putchar ('\n');

	DisplayLocale (LC_CTYPE,    "LC_CTYPE"   );
	DisplayLocale (LC_NUMERIC,  "LC_NUMERIC" );
	DisplayLocale (LC_TIME,     "LC_TIME"    );
	DisplayLocale (LC_COLLATE,  "LC_COLLATE" );
	DisplayLocale (LC_MONETARY, "LC_MONETARY");
#ifdef LC_MESSAGES
	DisplayLocale (LC_MESSAGES, "LC_MESSAGES");
#endif

#if 0
	fputs ("LC_ALL      =  ", stdout);
	if (env_lc_all != NULL)
		fputs (env_lc_all, stdout);
	putchar ('\n');
#else
	DisplayLocale (LC_ALL, "LC_ALL");
#endif

	exit (EXIT_SUCCESS);
}
